ifneq ($(DOXYGEN),)
ALL_LOCAL+=doc-doxygen

#------------------------------------------------------------------------
# Dependencies
#------------------------------------------------------------------------
doc-doxygen: doxygen.cfg
	$(DOXYGEN) doxygen.cfg

doxygen.cfg: \
	Makefile.am $(ldas_top_srcdir)/build/make-macros/doxygen.mk \
	$(ldas_top_srcdir)/build/make-macros/doxygen.mk

#------------------------------------------------------------------------
# Build rules
#------------------------------------------------------------------------
doxygen.cfg:
	@file="doxygen.cfg"; \
	rm -f $$file; \
	echo '#--------------------------------------------' >> $$file;	\
	echo '# Project characteristics' >> $$file;			\
	echo '#--------------------------------------------' >> $$file;	\
	echo 'PROJECT_NAME=$(PACKAGE_NAME)' >> $$file;			\
	echo 'PROJECT_NUMBER=$(LDAS_PACKAGE_VERSION)' >> $$file;			\
	echo '#--------------------------------------------' >> $$file;	\
	echo '# Sources to use' >> $$file; 				\
	echo '#--------------------------------------------' >> $$file;	\
	echo 'INPUT=$(srcdir)/../src' >> $$file;			\
	echo 'FILE_PATTERNS=*.icc *.cc *.hh *.c *.h' >> $$file;		\
	echo '#--------------------------------------------' >> $$file;	\
	echo '# Filtering of the source (Converting from Perceps to doxygen)' >> $$file; \
	echo '#--------------------------------------------' >> $$file;	\
	echo 'FILTER_SOURCE_FILES=YES' >> $$file;			\
	echo 'INPUT_FILTER=$(ldas_top_srcdir)/lib/perceps/pce2_to_doxygen.pl' >> $$file; \
	echo 'VERBATIM_HEADERS=NO' >> $$file				\
	echo '#--------------------------------------------' >> $$file;	\
	echo '# Where to output' >> $$file; 				\
	echo '#--------------------------------------------' >> $$file;	\
	echo 'OUTPUT_DIRECTORY=doxygen' >> $$file;			\
	echo 'STRIP_FROM_PATH=$(srcdir)/../src' >> $$file;		\
	echo '#--------------------------------------------' >> $$file;	\
	echo '# Types of output' >> $$file;				\
	echo '#--------------------------------------------' >> $$file;	\
	echo 'GENERATE_HTML=YES' >> $$file;				\
	echo 'GENERATE_LATEX=YES' >> $$file;				\
	echo 'GENERATE_MAN=NO' >> $$file;				\
	echo '#--------------------------------------------' >> $$file;	\
	echo '# Source browsing related options' >> $$file;		\
	echo '#--------------------------------------------' >> $$file;	\
	echo 'INLINE_SOURCES=NO' >> $$file;
endif
