#include "framecpp/config.h"

#include <cstring>

#include <iomanip>
#include <iostream>

#include "framecpp/Common/MD5Sum.hh"

using std::memcpy;

FrameCPP::Common::MD5Sum::
MD5Sum( const MD5Sum& Source )
  : m_final( Source.m_final )
{
  memcpy( &m_context, &Source.m_context, sizeof( m_context ) );
  memcpy( m_message_digest, Source.m_message_digest, sizeof( m_message_digest ) );
}

FrameCPP::Common::MD5Sum& FrameCPP::Common::MD5Sum::
operator=( const MD5Sum& Source )
{
  m_final = Source.m_final;
  memcpy( &m_context, &Source.m_context, sizeof( m_context ) );
  memcpy( m_message_digest, Source.m_message_digest, sizeof( m_message_digest ) );
  return *this;
}

std::ostream& std::
operator<<( std::ostream& Stream, const FrameCPP::Common::MD5Sum& Data )
{
  Data.Value( );	// Do any finization
  //---------------------------------------------------------------------
  // Preserve stream formatting rules
  //---------------------------------------------------------------------

  std::ios_base::fmtflags	sflags( Stream.flags( ) );
  Stream.setf( std::ios_base::hex, std::ios_base::basefield );
  Stream.unsetf( std::ios_base::uppercase );

  std::streamsize swidth( Stream.width( 2 ) );
  int sfill( Stream.fill( '0' ) );

  //---------------------------------------------------------------------
  // Output our data
  //---------------------------------------------------------------------

  for ( INT_2U i = 0; i < sizeof( Data.m_message_digest ); ++i )
  {
    Stream << std::hex << std::setw(2) << std::setfill('0') << (int)Data.m_message_digest[ i ];
  }

  //---------------------------------------------------------------------
  // Restore the formatting rules
  //---------------------------------------------------------------------

  Stream.width( swidth );
  Stream.fill( sfill );
  Stream.flags( sflags );

  return Stream;
}
