#ifndef FRAME_CPP__DETECTOR_MAP
#define FRAME_CPP__DETECTOR_MAP

#include <string>

#include "general/Singleton.hh"
#include "general/hash_map.hh"

namespace FrameCPP
{
  class DETECTOR_MAP
  {
    SINGLETON_TS_DECL( DETECTOR_MAP );

  public:
    static const char* DetectorToPrefix( const std::string& Detector );

  private:
    typedef General::hash_map< const char*, const char* >
    detector_map_type;

    static detector_map_type m_detector_to_prefix;
  };
}

#endif /* FRAME_CPP__DETECTOR_MAP */
