#ifndef FRAME_CPP_INTERFACE__FrameReader_HH
#define FRAME_CPP_INTERFACE__FrameReader_HH

#include <iostream>
#include <memory>
#include <string>

#include "framecpp/FrameH.hh"

namespace FrameCPP
{
  class FrameReader
  {
  public:
    FrameReader( );

    FrameReader( std::istream& InStream, bool AutoReset = false );

    ~FrameReader( );

    void SetStream( std::istream& InStream, bool AutoReset = false );

    bool isEndOfFile( ) const;

    void setErrorWatch( void(*ErrorWatch)(const std::string&) );

    FrameH* readFrame( );

  private:
    struct private_type;
    private_type*	m_private;

    const private_type& p( ) const;
    private_type& p( );
  };

  inline const FrameReader::private_type& FrameReader::
  p( ) const
  {
    return *m_private;
  }

  inline FrameReader::private_type& FrameReader::
  p( )
  {
    return *m_private;
  }
}

#endif /* FRAME_CPP_INTERFACE__FrameReader_HH */
