#include "framecpp/config.h"

#include <memory>

#include "framecpp/Version6/FrSE.hh"
#include "framecpp/Version6/IFrameStream.hh"
#include "framecpp/Version6/OFrameStream.hh"

using namespace FrameCPP::Version_6;


FrSE::
FrSE( )
  : FrBase( FrBase::CLASS_FR_SE )
{
}

FrSE::
FrSE( const std::string& Name,
      const std::string& ClassId,
      const std::string& Comment )
  : FrBase( CLASS_FR_SE )
{
  m_data.name = Name;
  m_data.classId = ClassId;
  m_data.comment = Comment;
}


const CHAR* FrSE::getStaticName()
{
   static const CHAR* class_name( "FrSE" );
   return class_name;
}


std::string FrSE::GetName() const
{
   return m_data.name;
}


INT_8U FrSE::
Bytes( ) const
{
  return FrBase::Bytes( ) +
    m_data.name.Bytes( ) +
    m_data.classId.Bytes( ) +
    m_data.comment.Bytes( );
}

void FrSE::
read( IFrameStream& Stream, const FrBase& Base )
{
  SetInstance( Base.GetInstance( ) );
  Stream >> m_data.name
	 >> m_data.classId
	 >> m_data.comment;
}

FrSE* FrSE::
ReadDynamic( IFrameStream& Stream, const FrBase& Base )
{
  std::auto_ptr< FrSE > ret( new FrSE );
  ret->read( Stream, Base );
  ret->SetInstance( Base.GetInstance( ) );
  return ret.release( );
}

void FrSE::
Write( OFrameStream& Stream ) const
{
  Stream << m_data.name
	 << m_data.classId
	 << m_data.comment;
}
