#ifndef FrameCPP_VERSION_6_FrSE_HH
#define FrameCPP_VERSION_6_FrSE_HH

#include "framecpp/Version6/FrBase.hh"
#include "framecpp/Version6/STRING.hh"

namespace FrameCPP
{
  namespace Version_6
  {
    class FrSE: public FrBase
    {
    public:

      static const CHAR* getStaticName();

      //: Default constructor
      FrSE( );

      //: constructor
      FrSE( const std::string& Name,
	    const std::string& ClassId,
	    const std::string& Comment = "" );

      //: Return the number of bytes needed to write this object
      INT_8U Bytes( ) const;

      //: Return class of object
      std::string GetClass( ) const;

      //: Return comment of object
      std::string GetComment( ) const;

      //: Return name of object
      std::string GetName( ) const;

      //: Read the structure from stream
      void read( IFrameStream& Stream, const FrBase& Base );

      //: Read the structure from stream
      static FrSE* ReadDynamic( IFrameStream& Stream, const FrBase& Base );

      //: Write the structure to the stream
      virtual void Write( OFrameStream& Stream ) const;

    private:
      struct image_t
      {
	STRING	name;
	STRING	classId;
	STRING	comment;
      } m_data;
    }; // class - FrSE

    inline std::string FrSE::
    GetClass( ) const
    {
      return m_data.classId;
    }

    inline std::string FrSE::
    GetComment( ) const
    {
      return m_data.comment;
    }
  } // namespace - Version_6
} // namespace - FrameCPP
#endif /* FrameCPP_VERSION_6_FrSE_HH */
