#include "framecpp/config.h"

#include <memory>

#include "framecpp/Version6/FrSH.hh"
#include "framecpp/Version6/IFrameStream.hh"
#include "framecpp/Version6/OFrameStream.hh"

using namespace FrameCPP::Version_6;


FrSH::
FrSH( )
  : FrBase( CLASS_FR_SH )
{}


FrSH::
FrSH( const std::string& Name, INT_2U ClassId, const std::string& Comment )
  : FrBase( FrBase::CLASS_FR_SH )
{
  m_data.name = Name;
  m_data.classId = ClassId;
  m_data.comment = Comment;
}


const CHAR* FrSH::getStaticName()
{
   static const CHAR* class_name( "FrSH" );
   return class_name;
}


std::string FrSH::GetName( ) const
{
   return m_data.name;
}


INT_8U FrSH::
Bytes( ) const
{
  return FrBase::Bytes( ) +
    m_data.name.Bytes( ) +
    sizeof( m_data.classId ) +
    m_data.comment.Bytes( );
}

void FrSH::
read( IFrameStream& Stream, const FrBase& Base )
{
  SetInstance( Base.GetInstance( ) );
  Stream >> m_data.name
	 >> m_data.classId
	 >> m_data.comment;
}

FrSH* FrSH::
ReadDynamic( IFrameStream& Stream, const FrBase& Base )
{
  std::auto_ptr< FrSH > ret( new FrSH );
  ret->read( Stream, Base );
  ret->SetInstance( Base.GetInstance( ) );
  return ret.release( );
}

void FrSH::
Write( OFrameStream& Stream ) const
{
  Stream << m_data.name
	 << m_data.classId
	 << m_data.comment;
}
