#ifndef FrameCPP_VERSION_6_Frame5ReaderBase_HH
#define FrameCPP_VERSION_6_Frame5ReaderBase_HH

#include "framecpp/Version3_4_5/framereaderbase.hh"

#include "framecpp/Version6/FrEndOfFile.hh"
#include "framecpp/Version6/FrTOC.hh"

namespace FrameCPP
{
  namespace Version_3_4_5
  {
    class FileHeader;
  }

  namespace Version_6
  {
    class Frame5ReaderBase
      : public ::FrameCPP::Version_3_4_5::FrameReaderBase
    {
    public:
      //-----------------------------------------------------------------
      //
      //: Constructor
      //
      //!param: std::istream& in - The stream to read from.
      //
      //!exc: None.
      //      
      Frame5ReaderBase( std::istream& in,
			::FrameCPP::Version_3_4_5::FileHeader* fh );
      
      //-----------------------------------------------------------------
      // Expose some things that we need access to.
      //-----------------------------------------------------------------
      typedef FrameReaderBase::LinkedListStart LinkedListStart;
      typedef FrameReaderBase::Pointers Pointer;

      FrameReaderBase::mLinkedListStart;
      FrameReaderBase::mLinkedListNodes;
      FrameReaderBase::mPointers;

    public:
      std::istream& m_in;
    private:
      // These routines need access to the protected Version_3_4_5::Input
      //   class of Version_3_4_5::FrameReaderBase
      friend class FrTOC;
      friend class FrEndOfFile;
    }; // class - Frame5ReaderBase
  } // namespace - Version_6
} // namespace - FrameCPP
#endif /* FrameCPP_VERSION_6_FrameReaderBase_HH */
