#ifndef FrameCPP_VERSION_6_PTR_STRUCT_HH
#define FrameCPP_VERSION_6_PTR_STRUCT_HH

#include <string>

#include "general/types.hh"

namespace FrameCPP
{
  namespace Version_6
  {
    struct PTR_STRUCT
    {
      INT_2U	data_class;
      INT_4U	data_instance;

      PTR_STRUCT( );

      PTR_STRUCT( INT_2U ClassId, INT_4U Instance );

      PTR_STRUCT( const PTR_STRUCT& Source );

      const PTR_STRUCT& operator=( const PTR_STRUCT& RHS );

      bool operator==( const PTR_STRUCT& RHS ) const;

      bool operator!=( const PTR_STRUCT& RHS ) const;

      static INT_8U Bytes( );

      static std::string Desc( const std::string& Type );
    };

    inline PTR_STRUCT::
    PTR_STRUCT( )
      : data_class( 0 ),
	data_instance( 0 )
    {
    }

    inline PTR_STRUCT::
    PTR_STRUCT( INT_2U ClassId, INT_4U Instance )
      : data_class( ClassId ),
	data_instance( Instance )
    {
    }

    inline bool PTR_STRUCT::
    operator==( const PTR_STRUCT& RHS ) const
    {
      return ( ( RHS.data_class == data_class ) &&
	       ( RHS.data_instance == data_instance ) );
    }

    inline bool PTR_STRUCT::
    operator!=( const PTR_STRUCT& RHS ) const
    {
      return ! ( *this == RHS );
    }
    inline INT_8U PTR_STRUCT::
    Bytes( )
    {
      return sizeof( INT_2U ) + sizeof( INT_4U );
    }

    static const PTR_STRUCT NULL_PTR_STRUCT( 0, 0);
  } // namespace - Version_6
} // namespace - FrameCPP
#endif /* FrameCPP_VERSION_6_PTR_STRUCT_HH */
