#ifndef FrameCPP_VERSION_6_STRING_HH
#define FrameCPP_VERSION_6_STRING_HH

#include <string>

#include "general/types.hh"

namespace FrameCPP
{
  namespace Version_6
  {
    class STRING : public std::string
    {
    public:
      typedef INT_2U length_of_string_type;

      static const INT_4U MAX_STRING_LENGTH;

      STRING( );

      STRING( const std::string& Value );

      STRING( const char* Value );

      //: Calculate the number of bytes needed to write this object
      INT_8U Bytes( ) const;

      static INT_8U Bytes( const std::string& String );

      STRING& operator=( const std::string& Source );

      STRING& operator=( const char* Source );

    private:
      static void	length_error( const std::string& Value );
      static void	length_error( const char* Value );

    }; // class - STRING


  } // namespace - Version_6
} // namespace - FrameCPP

#endif /* FrameCPP_VERSION_6_STRING_HH */
