#include "framecpp/config.h"

#include <fstream.h>

#include "framecpp/frame.hh"
#include "framecpp/framereader.hh"

using FrameCPP::Frame;
using FrameCPP::RawData;
using FrameCPP::AdcData;
using FrameCPP::FrameReader;

main(int argc, char *argv[])
{
    ifstream in( argv[1] );
    FrameReader r( in );

    Frame* f( r.readFrame() );

    RawData* raw = f->getRawData();

    char type;
    char q[ 500 ];
    RawData::adcData_iterator iter( raw->refAdc().begin() );
    RawData::AdcDataContainer& adc( raw->refAdc() );
    
    do
    {
        for (int i=0;i < raw->refAdc().getSize(); ++i )
        {
            cout << raw->refAdc()[ i ]->getName() << " ";
        }
        
        cout << "\n1: normal\n2: next normal\n3: regex\n4: next regex\n5: hash\n6: Quit\n\nType? ";
        cin >> type;

        if ( type != '6' )
        {
            cout << "Query? ";
            cin >> q;
        }
        adc.rehash();
        
        switch( type )
        {
            case '1':
                iter = adc.find( q, adc.begin() );
                if ( iter != adc.end() )
                    cout << (*iter)->getName() << endl;
                else
                    cout << "NOT FOUND" << endl;
                break;

            case '2':
                if ( iter == adc.end() )
                {
                    cout << "NOT FOUND" << endl;
                    break;
                }
                
                iter = adc.find( q, ++iter );
                if ( iter != adc.end() )
                    cout << (*iter)->getName() << endl;
                else
                    cout << "NOT FOUND" << endl;
                break;
                
            case '3':
                iter = adc.regexFind( q, adc.begin() );
                if ( iter != adc.end() )
                    cout << (*iter)->getName() << endl;
                else
                    cout << "NOT FOUND" << endl;
                break;

            case '4':
                if ( iter == adc.end() )
                {
                    cout << "NOT FOUND" << endl;
                    break;
                }
                
                iter = adc.regexFind( q, ++iter );
                if ( iter != adc.end() )
                    cout << (*iter)->getName() << endl;
                else
                    cout << "NOT FOUND" << endl;
                break;
                
            case '5':
                pair< RawData::adcData_hash_iterator,
                    RawData::adcData_hash_iterator > p( adc.hashFind( q ) );
                for ( RawData::adcData_hash_iterator hiter = p.first;
                      hiter != p.second; ++hiter )
                {
                    cout << hiter->second->getName() << endl;
                }
                if ( p.first == p.second )
                {
                    cout << "NOT FOUND" << endl;
                }
                break;
        }
        
        cout << endl;
        
    }
    while( type != '6' );
    
    in.close();
}
