#include "framecpp/config.h"

#include <iostream.h>
#include <fstream.h>
#include <vector>

#include "../src/framereadplan.hh"
#include "../src/dump.hh"

void error_watch (const string& msg)
{
  cerr << msg << endl;
}

// M1:DAQ-EDCU_TEST_000.rms
string names[] = { "M0:DAQ-ADCU4k2_chanCount.min", "M1:DAQ-EDCU_TEST_000.rms"};


int main(int argc, char *argv[])
try {
  ifstream tin (argv[1]);
  FrameCPP::FrameReadPlan fr( tin ); // Create the maps

  vector<string> adcNames;
  for (unsigned i = 0; i < 2; i++)
    adcNames.push_back(names[i]);

  fr.daqTriggerADC( adcNames ); // Specify what I want

  // Update using the maps and dump the contents
  for (int i = 2; i < argc; i++) {
    ifstream tin1 (argv[i]);
    const FrameCPP::Frame& frame = fr.readFrame( tin1, 0 );
    dump( cout, const_cast<FrameCPP::Frame&>( frame ) );
  }

} catch ( exception& ex ) {
  cerr << "failed " << ex.what() << endl;
}
