#include <list>

#include "general/Singleton.hh"

namespace General
{
  class AtExit
  {
    // Declare public methods generic to Singleton class:
    // see "general" library
    SINGLETON_TS_DECL( AtExit );

  public:
    typedef void (*ExitFunction)( );

    static void Append( ExitFunction Function );

    static bool IsExiting( );

  private:
    // Stack to keep track of exit functions to call.
    struct exit_function_node {
      ExitFunction		m_function;
      exit_function_node*	m_previous;

      exit_function_node( ExitFunction Function,
			  exit_function_node* Previous )
	: m_function( Function ),
	  m_previous( Previous )
      {
      }
    };

    static exit_function_node*	m_head_function;
    static bool			m_is_exiting;

    ~AtExit( );
  };

  inline bool AtExit::
  IsExiting( )
  {
    return m_is_exiting;
  }
}
