/* -*- mode: c++; c-basic-offset: 2; -*- */

#ifndef GENERAL__CONDITIONAL_VARIABLE_HH
#define GENERAL__CONDITIONAL_VARIABLE_HH

#include <pthread.h>

#include "general/types.hh"
#include "general/mutexlock.hh"

namespace General
{
  class ConditionalVariable
  {
  public:
    ConditionalVariable( );
    ~ConditionalVariable( );
    void Broadcast( );
    MutexLock::lock_type& Mutex( );
    void Signal( );
    bool TimedWait( INT_4U Seconds );
    void Wait( );

  private:
    typedef pthread_cond_t cond_type;

    cond_type			m_var;
    MutexLock::lock_type	m_lock;

    ConditionalVariable( const ConditionalVariable& Source );
    ConditionalVariable& operator=( const ConditionalVariable& Source );
  };

  inline MutexLock::lock_type& ConditionalVariable::
  Mutex( )
  {
    return m_lock;
  }
}

#endif /* GENERAL__CONDITIONAL_VARIABLE_HH */

