#include <iostream>
#include <list>

#include "general/mutexlock.hh"

namespace General
{
  class IOLock
  {
  public:
    static pthread_mutex_t*	GetKey( const std::ostream& Stream );

  private:
    struct lock_set {
      const void*	key;
      pthread_mutex_t	lock;
    };
    typedef std::list< lock_set* >	keys_ostream_type;

    static pthread_mutex_t		m_key_ostream;

    static keys_ostream_type		m_keys_ostream;
  }; // class - IOLock
} // namespace - General
