#include "general/config.h"

#include <list>

#include "general/mutexlock.hh"
#include "general/SingletonT.hh"

namespace General
{
  class TaskThread;

  class ThreadPoolClient
    : public General::SingletonClient
  {
  public:
    ThreadPoolClient( );

    ~ThreadPoolClient( );

    TaskThread* Acquire( );

    void Relinquish( TaskThread* Slot );

  private:
    typedef	std::list< TaskThread* >	thread_container_type;

    MutexLock::lock_type	m_queue_lock;
    thread_container_type	m_in_use;
    thread_container_type	m_available;
  };

  typedef General::Singleton< ThreadPoolClient > ThreadPoolSingleton;
  
  extern ThreadPoolClient& ThreadPool;
}
