#ifndef FormatExceptionHH
#define FormatExceptionHH

#include "general/config.h"

#include "general/ldasexception.hh"

//-----------------------------------------------------------------------------
//
//: Format Exception
//
// This class is derived from LdasException.  It does not define any new
// methods or data.  It is used simply to differentiate between error types
// when thrown.
//
class FormatException : public LdasException
{
public:

    /* Constructors */
    FormatException( int library, int code, const std::string& msg = "",
                     const std::string& info = "", const char* file = 0,
                     size_t line = 0 ) throw();
};


//-----------------------------------------------------------------------------
//
//: Constructor.
//
// Just call the LdasException constructor.
//
//!param: int library
//!param: int code
//!param: const string& msg
//!param: const string& info
//!param: const char* file
//!param: size_t line
//
inline FormatException::FormatException(
    int library, int code, const std::string& msg, const std::string& info,
    const char* file, size_t line )
    throw()
        : LdasException( library, code, msg, info, file, line )
{}

#endif // FormatExceptionHH
