// -*- mode: c++; c-basic-offset: 4; -*-
// $Id: toss.cc,v 1.7 2006/01/23 22:54:12 emaros Exp $
#ifndef GENERAL__TOSS_CC
#define GENERAL__TOSS_CC

#include "general/config.h"

#include <sstream>
#include <stdexcept>

#include "toss.hh"
#include "unimplemented_error.hh"

namespace {
  static const char GeneralTossCC_rcsID[] =
  "@(#) $Id: toss.cc,v 1.7 2006/01/23 22:54:12 emaros Exp $:";
}

namespace General {

    template <class T>
    void toss(const std::string& cl,
	      const std::string& fl, 
	      int           ln, 
	      const std::string& de)
    {
	std::ostringstream oss;
	oss << cl << "(" << fl << ":" << ln << "): " << de;
	std::string what = oss.str();
	throw T(what);
    }
    
    // Instantiate for std::exception types
    
#define INSTANTIATE(EXCEPT_TYPE) \
template void toss<EXCEPT_TYPE> ( const std::string& cl, \
                                  const std::string& fl, \
                                  int ln, \
                                  const std::string& de )

    //!begin_ignore:
    INSTANTIATE(std::logic_error);
    INSTANTIATE(std::domain_error);
    INSTANTIATE(std::invalid_argument);
    INSTANTIATE(std::length_error);
    INSTANTIATE(std::out_of_range);
    INSTANTIATE(std::runtime_error);
    INSTANTIATE(std::range_error);
    INSTANTIATE(std::overflow_error);
    INSTANTIATE(std::underflow_error);
    INSTANTIATE(General::unimplemented_error);
    //!end_ignore:

#undef INSTANTIATE

} // namespace General

#endif /* GENERAL__TOSS_CC */
